%% script4


%%

clear
close all
load pts1
rgb = imread(filename);
% rgb = imresize(rgb,0.25);


%% starting image

kp(1,:) = pts(1,:) - pts(2,:);
kp(2,:) = pts(3,:) - pts(4,:);
for k=1:2
    kp(k,:) = kp(k,:)/norm(kp(k,:));
end
s = det(kp(1:2,:));
s = asin(s)*180/pi;
str = sprintf('divergence %g deg',s);
disp(str);
imshow(rgb);
hold on
plot(pts(1:2,1),pts(1:2,2),'b','LineWidth',2);
plot(pts(3:4,1),pts(3:4,2),'b','LineWidth',2);
hold off
title(str);


%% find zero divergence

KK = [6500 0 0; 0 6500 0; 2000 1000 1];
clear ang dang
ang(1) = -60;
ang(2) = ang(1)-1;
dang(1) = div_angle(ang(1),pts,KK);
dang(2) = div_angle(ang(2),pts,KK);

for k=1:5
    q = -dang(1)/(dang(2)-dang(1));
    anew = ang(1)+(ang(2)-ang(1))*q;
    dang(1) = dang(2);
    ang(1) = ang(2);
    ang(2) = anew;
    dang(2) = div_angle(ang(2),pts,KK);
    if abs(dang(2))<1e-6
        break;
    end
end

[da,tf] = div_angle(anew,pts,KK);
str = sprintf('angle %g deg   divergence %g deg',anew,da);

[x, y] = transformPointsForward(tf,pts(:,1),pts(:,2));
pts2 = [x y];


%% wide view


ymax = max(y);
% vary spread to change extent of image
spread = 20000;
xrng = [min(x)-spread max(x)+spread];
diff = xrng(2)-xrng(1);
yrng = [ymax-diff ymax];
myref = imref2d([800 800],xrng,yrng);
[img, ref] = imwarp(rgb,tf,'OutputView',myref,'FillValues',[255 255 200]);
imshow(img);
ref

[xp, yp] = worldToIntrinsic(myref,x,y);
hold on
plot(xp(1:2),yp(1:2),'b','LineWidth',2);
plot(xp(3:4),yp(3:4),'b','LineWidth',2);
hold off
title(str);



%% narrow view

ymax = max(pts2(:,2));
spread = 2000;
xrng = [min(pts2(:,1))-spread max(pts2(:,1))+spread];
diff = xrng(2)-xrng(1);
yrng = [ymax-diff ymax];

myref = imref2d([800 800],xrng,yrng);
[img, ref] = imwarp(rgb,tf,'OutputView',myref,'FillValues',[255 255 200]);
imshow(img);

% pts3 = pts2;
% pts3(2,:) = pts2(1,:) + 0.5*(pts2(2,:)-pts2(1,:));

[xp, yp] = worldToIntrinsic(myref,pts2(:,1),pts2(:,2));
hold on
plot(xp(1:2),yp(1:2),'b','LineWidth',2);
plot(xp(3:4),yp(3:4),'b','LineWidth',2);
hold off

title(str);
ref



